<?php include 'common.php'; header('Content-Type: text/html; charset=utf-8'); ?><!DOCTYPE html>
<html lang="no">
<head>
    <title><?=title();?></title>
    <meta charset='UTF-8'>
    <link rel="stylesheet" href="index.css">
</head>
<body>

<div class="container">
    <h1><?=title();?></h1>
    <h4><?=getNavigation();?></h4>
    <h2>Sjekk av etternavn</h2>

    <?php

    // Lagt inn i en funksjon for enklere bruk senere.
    function capitalize($input){
        // Den innebygde funksjonen `mb_convert_case` med mode: MB_CASE_TITLE gjør at forbokstaven i hvert ord blir stor, med encodingen UTF-8. Det betyr at den også fungerer med æ, ø og å.
        return mb_convert_case($input, MB_CASE_TITLE, "UTF-8");
    }

    // Henter etternavn fra GET, eller setter et standard.
    $etternavn = $_GET['etternavn'] ?? 'kArLsEn';

    $fintEtternavn = capitalize($etternavn);
    ?>

    <p>Etternavn: <strong><?=$etternavn;?></strong></p>
    <p>Etternavnet etter det er gjort finere: <strong><?=$fintEtternavn;?></strong></p>
    <p>Etternavnet er <code><?=mb_strlen($fintEtternavn);?> karakterer langt</code>.</p>
    <br>
    <p>
        <form>
            <input type="text" name="etternavn" value="<?=$etternavn;?>">
            <input type="submit" value="Sjekk navn...">
        </form>
    </p>
</div>

</body>
</html>
